package main

import (
	"fmt"
	"log"
	"os"
	"reflect"
	"strings"

	"github.com/nicklaw5/helix/v2"
)

const header = `// Code generated by helical. DO NOT EDIT.
//  based on github.com/nicklaw5/helix/v2

package helical

import (
	"fmt"

	"github.com/nicklaw5/helix/v2"
)

`

const headerInterface = `// Code generated by helical. DO NOT EDIT.
//  based on github.com/nicklaw5/helix/v2

package helical

import (
	"github.com/nicklaw5/helix/v2"
)

`

func main() {
	typ := reflect.TypeOf(&helix.Client{})

	f, err := os.OpenFile("wrapper.go", os.O_CREATE|os.O_TRUNC|os.O_WRONLY, 0664)
	if err != nil {
		log.Fatalln(err)
	}
	defer f.Close()

	_, err = fmt.Fprint(f, header)
	if err != nil {
		log.Fatalln(err)
	}

	var signatures []string

	for v := 0; v < typ.NumMethod(); v++ {
		method := typ.Method(v)
		signature, content := generate(method)
		_, err = fmt.Fprintln(f, content)
		if err != nil {
			log.Fatalf("writing method %s: %s", method.Name, err)
		}
		signatures = append(signatures, signature)
	}

	err = writeSignatures(signatures)
	if err != nil {
		log.Fatalln("writing signatures:", err)
	}
}

func writeSignatures(signatures []string) error {
	f, err := os.OpenFile("client_interface.go", os.O_CREATE|os.O_TRUNC|os.O_WRONLY, 0664)
	if err != nil {
		return err
	}
	defer f.Close()

	_, err = fmt.Fprint(f, headerInterface)
	if err != nil {
		return fmt.Errorf("writing header: %w", err)
	}

	interf := fmt.Sprintf(
		`type Client interface{
%s
}`, strings.Join(signatures, "\n"))

	_, err = fmt.Fprintln(f, interf)
	if err != nil {
		return fmt.Errorf("writing client interface: %w", err)
	}
	return nil
}

func generate(method reflect.Method) (signature string, content string) {
	in := []string{}
	inNames := []string{}
	for i := 1; i < method.Type.NumIn(); i++ {
		typ := method.Type.In(i)
		inName := fmt.Sprintf("arg%d", i)
		in = append(in, inName+" "+typ.String())
		inNames = append(inNames, inName)
	}

	out := []string{}
	outNames := []string{}
	varNames := []string{}
	var hasErrOut, hasResponse bool

	for i := 0; i < method.Type.NumOut(); i++ {
		typ := method.Type.Out(i)
		if i == 0 && typ.Kind() == reflect.Pointer {
			_, hasResponse = typ.Elem().FieldByName("ResponseCommon")
		}
		out = append(out, typ.String())
		name := fmt.Sprintf("out%d", i)
		varNames = append(varNames, name)
		outNames = append(outNames, name)
	}

	if len(out) > 0 {
		if out[len(out)-1] == "error" {
			hasErrOut = true
		}
	}

	errBlock := ""
	errVariable := ""
	if hasErrOut {
		errVariable = outNames[len(outNames)-1]
		errBlock = fmt.Sprintf(
			`if %s != nil {
		return
	}`, errVariable)
	}

	responseBlock := ""
	if hasResponse {
		if !hasErrOut {
			panic(fmt.Errorf("method %s: can’t return ResponseCommon without error", method.Name))
		}
		field, ok := method.Type.Out(0).Elem().FieldByName("Data")
		if ok {
			responseBlock = fmt.Sprintf(`if resp.ResponseCommon.ErrorMessage != "" {
			%s = fmt.Errorf(
				"%s: (%%d: %%s): %%s", resp.ResponseCommon.StatusCode, resp.ResponseCommon.ErrorMessage, resp.ResponseCommon.Error,
			)
			return 
	}
	out0 = resp.Data`, errVariable, method.Name)
			out[0] = field.Type.String()
			varNames[0] = "resp"
		} else {
			outNames[0] = "_"
			varNames[0] = "_"
			hasResponse = false
		}
	}

	outStr := ""
	if len(out) > 0 {
		strs := []string{}
		for i, typename := range out {
			strs = append(strs, outNames[i]+" "+typename)
		}
		outStr = fmt.Sprintf("(%s)", strings.Join(strs, ", "))
	}

	equals := " = "
	if hasResponse {
		equals = " := "
	}
	if len(outNames) == 0 {
		equals = ""
	}

	return fmt.Sprintf(
			"\t%s(%s) %s",
			method.Name,
			strings.Join(in, ", "),
			outStr,
		), fmt.Sprintf(
			`func (self *client) %s(%s) %s {
	%s%sself.helix.%s(%s)
	%s
	%s
	return
}`+"\n",
			method.Name,
			strings.Join(in, ", "),
			outStr,

			strings.Join(varNames, ", "),
			equals,
			method.Name,
			strings.Join(inNames, ", "),

			errBlock,
			responseBlock,
		)
}
